<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	class Login extends CI_Controller {
		/*
		 *	Constructor
		 */
		function __construct() {
			parent::__construct();
			
			//Load required library
			$this->load->model('user', '', TRUE);
		}
	
		
		/*
		 *	This function runs when the user navigates directly to the login controller
		 */
		public function index() {
			//If user is already logged in
			if($this->user->isLoggedIn()) {
				//User already logged in
				redirect(base_url().'home', 'refresh');
			} else {
				//Display the login form
				$this->drawLoginForm('');
			}
		}
		
		
		/*
		 *	This function validate the user input from login form using the library "form_validation".
		 *  NOTICE: This does NOT mean that it validates it against the database.
		 */
		public function validate() {
			//Load required library
			$this->load->library('form_validation');
			
			//Sets validation rules
			$this->form_validation->set_rules('username', 'Username', 'trim|required|xss_clean');
			$this->form_validation->set_rules('password', 'Password', 'trim|required|xss_clean');
			
			//Run validation
			if($this->form_validation->run() == FALSE) {
				//Field validation failed. Display login form (with error message).
				$this->drawLoginForm(validation_errors());
			} else {
				$username = $this->input->post('username');
				$password = $this->input->post('password');
				
				//Try to login
				if ($this->user->login($username, $password)) {
					redirect(base_url().'home', 'refresh');
				} else {
					$this->drawLoginForm('Access denied!');
				}
			}	
		}
		
	
		/*
		 *	This function draws the login form.
		 */
		private function drawLoginForm($errors) {
			//Load required library
			$this->load->helper(array('form'));
			
			//Display the view
			$data['error'] = $errors;
			$this->load->view('login_view', $data);
		}
	}
?>